program ZeitgleichungundAnalemma; (* Compilieren mit Compiler-Flag "Graf"! *) (* 5. Mrz 2008 *)

uses
  Forms,
  WinTypes,
  Graphics,
  ExtCtrls,
  Types,
  KernGraf in 'c:\sources.del\KernGraf.pas',
  Kern2Graf in 'c:\sources.del\Kern2Graf.pas',
  ModulGraf in 'c:\sources.del\ModulGraf.pas',
  Eingabe in 'c:\sources.del\EINGABE.PAS' {EingabeDialog},
  Mathe in 'c:\sources.del\mathe.pas',
  AstrRout in 'c:\sources.del\Astrrout.pas',
  Planets1 in 'c:\sources.del\PLANETS1.PAS',
  FensterGraf in 'c:\sources.del\FensterGraf.pas',
  ModKugelDelphi in 'c:\sources.del\ModKugelDelphi.pas';

{$R *.RES}

const Titel = 'RahmenGraf';        (* Dieser Text wird in der Info-Box angezeigt: *)
      Version = '1.3';
      prDatum = '26.11.2003';
      inBitmap = true;
      Infotext = false;
      Startbild = false;
      Fontname = 'Courier';
      Fontsize = 10;
      Fontstyle = 0;

var Taste, BildNr: integer;
    Abbruch, Pause, Einzelschritt, init: boolean;
    Infodatei, Bildname, rStr: String;

procedure initGrafik;

   begin
   zCanvas:=Grundfenster.GrafikBMP.Canvas;
   zCanvas.Font:=Grundfenster.Canvas.Font;
   end;

var Durchlaeufe: integer;                (* ... zhlt die Schleifendurchlufe *)

const Datum0: Zeitpunkt = (Tag: 0; Monat: 1; Jahr: 2002);
      exakt = false;                  (* exakte Berechnung der Zeitgleichung? *)
      ProjWinkel = 15.0;
      jdFaktor = 3.0;
      EklSchiefe = 23.5*Grad;
      exErde = 0.01671;
      geogrBreite = 40.0;

type bahndaten = RECORD
                    jd   : real;                     (* Referenzdatum *)
                    i    : real;                       (* Bahnneigung *)
                    kl   : real;                       (* Knotenlnge *)
                    omega: real;                      (* Perihellnge *)
                    m    : real;                   (* mittl. Anomalie *)
                    ex   : real;                     (* Exzentrizitt *)
                    my   : real;             (* mittl. tgl. Bewegung *)
                    a    : real;                   (* groe Halbachse *)
                    p    : real;
                    END;

var Schiefe, Exzentrizitaet, Rueckseite: boolean;
    RueckseiteC: Char;
    i: integer;
    jd0, jd, zg0, zg10, Mez, alphaS0, Summand: real;
    mA, exz, E: real;
    Erdbahn: Bahndaten;
    lambdal, vlambda, alphal, valpha, delta, zgl, Tageslaengel, Tageslaenge1l: real;
    Dx: Matrix;
    p1, p2: pVektor;
    xAl, yAl, Verzoegerung: integer;
    zeichneZeitgleichung, zeichneAnalemma, zeichneTageslaenge, zeichnePunkt, zeichneHimmel, vorigeSonne: boolean;
    SchiefeFaktor, exzFaktor, deltam: real;
    SchiefeFaktorStr, exzFaktorStr, deltamStr: String;
    Veraenderung: boolean;
    VeraenderungC: Char;

procedure Initialisierung;

   begin
   SchiefeFaktorStr:='1.0';
   exzFaktorStr:='1.0';
   VeraenderungC:='n';
   deltamStr:='0.0';
   Infodatei:=Programmname+'.txt';
   Bildname:=Programmname;
(*   initGrafik;*)
   setzeVGAPalette;
   rStr:='1.0';
   init:=true;
   BildNr:=0;
   RueckseiteC:='j';
   with Erdbahn do
      begin
      jd:=2447892.00000;
      i:=0.00000;
      kl:=0.00000;
      omega:=102.76844*Grad;
      m:=357.12769*Grad;
      ex:=exErde;
      my:=0.98561*Grad;
      a:=1.0;
      p:=a*(1-ex*ex);
      end;
(*   ModKugel.geheNach:=lgeheNach;
   ModKugel.zeichneLinie:=lzeichneLinie;
   ModKugel.zieheLinieNach:=lzieheLinieNach;
   modKugel.setzeLinienbreite:=Kern2Graf.setzeLinienbreite;
   ModKugel.zeichneGrafstring:=lzeichneGrafstring;*)
   end;

function Zeitgl(Datum: Zeitpunkt; Mez: real): real;

   var y, L0, e, M, jh, Eklschiefe, ss, cs, zgl: real;

   begin
   jh:=julJahrhunderte(julDatum(Datum, Mez));
   berechneEkliptikschiefe(jh,Eklschiefe,ss,cs);
   if not Schiefe then
      begin
      Eklschiefe:=0.0; ss:=0.0; cs:=1.0
      end;
   y:=sqr(tan(0.5*Eklschiefe));
   L0:=(280.46645+jh*(36000.76983+jh*0.0003032))*Grad; (* mittlere Lnge der Sonne nach Meeus, S. 167 *)
   e:=0.016-jh*(0.000042037-jh*0.0000001236); (* Exzentrizitt der Erdbahn *)
   if not Exzentrizitaet then e:=0.0;
   M:=(357.52910+jh*(35999.05030-jh*(0.0001559+jh*0.00000048)))*Grad; (* mittlere Anomalie *)
   zgl:=y*sin(2.0*L0)-2.0*e*sin(M)+4.0*e*y*cos(2.0*L0)-0.5*sqr(y)*sin(4.0*
   L0)-1.25*sqr(e)*sin(2.0*M); (* nach Meeus, S. 192 *)
   while zgl>ZweiPi do zgl:=zgl-ZweiPi;
   Zeitgl:=zgl
   end;

function Keplergl(var E: real): real; far;

   begin
   Keplergl:=mA+exz*sin(E)-E;
   end;

function Keplergl1(var E: real): real; far;

   begin
   Keplergl1:=exz*cos(E)-1.0;
   end;

function alphaSonne(jd0, exErde, iErde: real): real;

   var nu, r, x, y, z, w, alpha, lambda: real;
       pErde: pVektor;

   begin
   if not Schiefe then iErde:=0.0;
   with Erdbahn do
      begin
      mA:=m+my*(jd0-jd)+deltam;
      if Exzentrizitaet then exz:=exErde else exz:=0.0;
      p:=a*(1-exz*exz);
(*      E:=0.001;*)
      while mA>ZweiPi do mA:=mA-ZweiPi;
      E:=Nullstelle(KeplerGl, KeplerGl1, E, 0.001*Grad, 1000);
      nu:=2.0*arctan(sqrt((1.0+exz)/(1.0-exz))*tan(0.5*E));
      r:=p/(1.0+exz*cos(nu));
      w:=nu+omega-kl;
      x:=r*(cos(kl)*cos(w)-sin(kl)*sin(w)*cos(i));
      y:=r*(sin(kl)*cos(w)+cos(kl)*sin(w)*cos(i));
      z:=r*sin(w)*sin(i);              (* kart. Koord. bzgl. der Sonne *)
      end;
   with pErde do AstrRout.berechnePolarK(x, y, z, r, Laenge, Breite);
   lambda:=Pi+pErde.Laenge;
   if lambda>ZweiPi then lambda:=lambda-ZweiPi;
   vlambda:=(lambda-lambdal)/Grad/jdFaktor;
   if vlambda<0.0 then vlambda:=vlambda+360.0;
   lambdal:=lambda;
   EclEqu(sin(iErde), cos(iErde), y, z);
   with pErde do AstrRout.berechnePolarK(x, y, z, r, Laenge, Breite);
   alpha:=Pi+pErde.Laenge;
   if alpha>ZweiPi then alpha:=alpha-ZweiPi;
   valpha:=(alpha-alphal)/Grad/jdFaktor;
   if valpha<0.0 then valpha:=valpha+360.0;
   alphal:=alpha;
   delta:=-pErde.Breite;
   alphaSonne:=alpha
   end;

const nrSpMax = 1000;

var xSp, ySp: array[0..nrSpMax] of integer;
    nrSp: integer;
    alphaSv, deltaSv: real;

procedure zeichnegrHimmelskugel(jd0, jd, alphaS0, alphaS, deltaS: real);

   var p: pVektor;
       r, rSl: rVektor;
       Dz, D: Matrix;
       i: integer;

   begin
   setzeFuelltyp(255, weiss, weiss);
   fuelleRechteck(xm-ym-100, ym div 2, ym, ym div 2);
   setzeBildschirmausschnitt(xm-ym-100, xm-100, ym div 2, ym+ym div 2);
   dimensioniereBildschirm(-1.0, 1.0, -1.0, 1.0);
   setzeTextausrichtung(1,0);
   waehleFont('Courier', 12, 1);
   if not Rueckseite
      then
         begin
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-1*zHoehe, 'Himmelskugel von auen', schwarz);
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-0*zHoehe, '(Mittagsblick von Sueden)', schwarz);
         end
      else
         begin
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-1*zHoehe, 'Himmelskugel von innen', schwarz);
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-0*zHoehe, '(Mittagsblick nach Sueden)', schwarz);
         end;
   waehleFont('Courier', 12, 0);
   VorderseiteDick:=false; RueckseiteDick:=false;
   if not Rueckseite
      then
         definierezDrehung(-alphaS0+HPi+Pi-(jd-jd0)*360.0/364.25*Grad+Summand/60*15*Grad, Dz)
      else
         definierezDrehung(-alphaS0+HPi-(jd-jd0)*360.0/364.25*Grad+Summand/60*15*Grad, Dz);
   multipliziereMatrizen(Dx, Dz, D);
   setzeFuelltyp(255, hellgruen, hellgruen);
   if not Rueckseite then fuelleEllipse(xPlot(0.0), yPlot(0.0), xPlot(1.0)-xPlot(0.0), yPlot(1.0*sin(ProjWinkel*Grad))-yPlot(0));
   zeichneKugel(D, 1.0, 10, 10, 5, schwarz);
   if not Rueckseite
      then
         begin
         VorderseiteDick:=true; RueckseiteDick:=false
         end
      else
         begin
         VorderseiteDick:=false; RueckseiteDick:=true
         end;
   zeichneBreitenkreis(D, 1.0, 0.0, 0, 360, 5, hellblau);          (* quator *)
   zeichneGrosskreis(D, 1.0, p1, p2, 5, rot, true);               (* Ekliptik *)
   with p do begin r:=1.0; Laenge:=alphaSv; Breite:=deltaSv; end;      (* vorh. Sonne *)
   Mathe.berechneCartK(p, rSl);
   dreherVektor(D, rSl);
   with p do begin r:=1.0; Laenge:=alphaS; Breite:=deltaS; end;      (* Sonne *)
   Mathe.berechneCartK(p, r);
   dreherVektor(D, r);
   setzeFuelltyp(255, hellrot, hellrot);
   xSp[nrSp]:=xPlot(r[1]); ySp[nrSp]:=yPlot(r[3]);
   fuelleEllipse(xSp[nrSp], ySp[nrSp], 5, 5);
   if vorigeSonne then
      begin
      setzeFuelltyp(255, rot, rot);
      fuelleEllipse(xPlot(rSl[1]), yPlot(rSl[3]), 5, 5);
      setzeFuelltyp(255, hellrot, hellrot);
      end;
   if nrSp<366.0/jdFaktor then Inc(nrSp);
   setzeLinienbreite(1);
   if zeichneAnalemma then for i:=0 to nrSp-1 do fuelleEllipse(xSp[i], ySp[i], 2, 2);
   setzeLinienbreite(3);
   zeichneLinie(xPlot(0), yPlot(0), xPlot(0), yPlot(1), schwarz);
   setzeFuelltyp(255, hellgruen, hellgruen);
   if Rueckseite then fuelleEllipse(xPlot(0.0), yPlot(0.0), xPlot(1.0)-xPlot(0.0), yPlot(1.0*sin(ProjWinkel*Grad))-yPlot(0));
   setzeFuelltyp(255, weiss, weiss);
   end;

procedure schreibeTitelzeile;

   begin
   waehleFont('Courier', 16, 1);
   setzeTextausrichtung(1,0);
   zeichneGrafstring(xm div 2, 2*zHoehe, 'Tageslnge und Zeitgleichung ohne Exzentrizitt und mit Achsneigung', weiss);
   if zeichneZeitgleichung and zeichneTageslaenge
      then
         begin
         if Exzentrizitaet and Schiefe
            then zeichneGrafstring(xm div 2, 2*zHoehe, 'Tageslnge und Zeitgleichung mit Exzentrizitt und mit Achsneigung', schwarz)
            else if Exzentrizitaet
                    then zeichneGrafstring(xm div 2, 2*zHoehe, 'Tageslnge und Zeitgleichung mit Exzentrizitt und ohne Achsneigung', schwarz)
                    else if Schiefe
                            then zeichneGrafstring(xm div 2, 2*zHoehe, 'Tageslnge und Zeitgleichung ohne Exzentrizitt und mit Achsneigung', schwarz)
                            else zeichneGrafstring(xm div 2, 2*zHoehe, 'Tageslnge und Zeitgleichung ohne Exzentrizitt und ohne Achsneigung', schwarz);
         end
      else if zeichneZeitgleichung
              then
                 begin
                 if Exzentrizitaet and Schiefe
                    then zeichneGrafstring(xm div 2, 2*zHoehe, 'Zeitgleichung mit Exzentrizitt und mit Achsneigung', schwarz)
                    else if Exzentrizitaet
                            then zeichneGrafstring(xm div 2, 2*zHoehe, 'Zeitgleichung mit Exzentrizitt und ohne Achsneigung', schwarz)
                            else if Schiefe
                                    then zeichneGrafstring(xm div 2, 2*zHoehe, 'Zeitgleichung ohne Exzentrizitt und mit Achsneigung', schwarz)
                                    else zeichneGrafstring(xm div 2, 2*zHoehe, 'Zeitgleichung ohne Exzentrizitt und ohne Achsneigung', schwarz);
                 end
              else
                 begin
                 if Exzentrizitaet and Schiefe
                    then zeichneGrafstring(xm div 2, 2*zHoehe, 'Tageslnge mit Exzentrizitt und mit Achsneigung', schwarz)
                    else if Exzentrizitaet
                            then zeichneGrafstring(xm div 2, 2*zHoehe, 'Tageslnge mit Exzentrizitt und ohne Achsneigung', schwarz)
                            else if Schiefe
                                    then zeichneGrafstring(xm div 2, 2*zHoehe, 'Tageslnge ohne Exzentrizitt und mit Achsneigung', schwarz)
                                    else zeichneGrafstring(xm div 2, 2*zHoehe, 'Tageslnge ohne Exzentrizitt und ohne Achsneigung', schwarz);
                 end;
   waehleFont('Courier', 10, 0);
   end;

procedure Vorbereitung;

   function MittelwertZeitgleichung(jd0, alphaS0: real): real;

      var jdl, Summe, alphaSl, alphaSml, zgl: real;
          i: integer;

      begin
      Summe:=0.0;
      jdl:=jd0;
      i:=0;
      while jdl <jd0+366.0 do
         begin
         jdl:=jdl+jdFaktor;
         Inc(i);
         alphaSl:=alphaSonne(jdl, exzFaktor*Erdbahn.ex, SchiefeFaktor*EklSchiefe);
         alphaSml:=alphaS0+Erdbahn.my*(jdl-jd0);
         while alphaSml>ZweiPi do alphaSml:=alphaSml-ZweiPi;
         zgl:=-(alphaSl-alphaSml)/Grad*4.0;
         while zgl>1000.0 do zgl:=zgl-1440;
         while zgl<-1000.0 do zgl:=zgl+1440;
         Summe:=Summe+zgl;
         end;
      MittelwertZeitgleichung:=Summe/i
      end;

   begin
   i:=0;
   Mez:=12.0;
   jd0:=julDatum(Datum0, Mez);
   zg0:=Zeitgl(Datum0, Mez)/ZweiPi*24.0*60.0;
   zgl:=zg0;
   alphaS0:=alphaSonne(jd0, exzFaktor*Erdbahn.ex, SchiefeFaktor*EklSchiefe);
   zg10:=0.0;
   loescheBildschirm;
   schreibeTitelzeile;
   setzeLinienbreite(1);
   if not Rueckseite
      then
         begin
         definierexDrehung(-(geogrBreite+ProjWinkel)*Grad, Dx);
         RueckseiteSichtbar:=false;
         end
      else
         begin
         definierexDrehung((geogrBreite+ProjWinkel)*Grad, Dx);
         RueckseiteSichtbar:=true;
         end;
   VorderseiteSichtbar:=not RueckseiteSichtbar;                                             (* 2 Punkte auf der Ekliptik: *)
   with p1 do begin r:=1.0; Laenge:=0.0*Grad; Breite:=0.0*Grad end;
   with p2 do begin r:=1.0; Laenge:=90.0*Grad; if Schiefe then Breite:=SchiefeFaktor*EklSchiefe else Breite:=0.0 end;
   zeichnegrHimmelskugel(jd0, jd0, alphaS0, alphaS0, delta);
   setzeBildschirmausschnitt(250, xm-50, 50, ym div 2-50);
   dimensioniereBildschirm(0.0, 366.0, -20.0, 20.0);
   setzeLinienbreite(1);
   zeichneXAchse(0.0, 0.0, 0.0, 366.0, 15.0, 3.0, 'Tage     ', schwarz, schwarz);
   setzeLinienbreite(2);
   waehleFont('Courier', 10, 1);
   zeichneYAchse(0.0, 0.0, -20.0, 20.0, 2.5, 1.0, 'Zeitgleichung in min', hellrot, hellrot);
   dimensioniereBildschirm(0.0, 366.0, -30.0, 30.0);
   zeichneYAchse(366.0, 0.0, -30.0, 30.0, 2.5, 1.0, '(Tageslnge-24h) in s', blau, blau);
   waehleFont('Courier', 10, 0);
(*   setzeLinienbreite(3);*)
   Durchlaeufe:=0;
   if Schiefe then Summand:=2.8 else Summand:=0.0; (* durch Ausprobieren gefunden *)
   Summand:=MittelwertZeitgleichung(jd0, alphaS0);
   Tageslaengel:=0.0; Tageslaenge1l:=0.0;
   geheNach(xPlot(i), yPlot(zg0));
   setzeTextausrichtung(0,0);
   zeichneGrafstring(0, ym-5-11*zHoehe, '  weiter mit Tastendruck:', hellrot);
   zeichneGrafstring(0, ym-5-10*zHoehe, '       "e": Einzelschritt an/aus,', hellrot);
   zeichneGrafstring(0, ym-5-9*zHoehe, '       "a": Zeichnung des Analemmas an/aus', hellrot);
   zeichneGrafstring(0, ym-5-8*zHoehe, '       "d": Diagrammpunkte an/aus', hellrot);
   zeichneGrafstring(0, ym-5-7*zHoehe, '       "h": Zeichnung des Himmels an/aus', hellrot);
   zeichneGrafstring(0, ym-5-6*zHoehe, '       "t": Zeichnung der Tageslnge an/aus', hellrot);
   zeichneGrafstring(0, ym-5-5*zHoehe, '       "z": Zeichnung der Zeitgleichung an/aus', hellrot);
   zeichneGrafstring(0, ym-5-4*zHoehe, '       "v": Sonne 30 Tage vorher an/aus,', hellrot);
   zeichneGrafstring(0, ym-5-3*zHoehe, '       "s": Bild speichern,', hellrot);
   zeichneGrafstring(0, ym-5-1*zHoehe, '     "Esc": neue Eingabe, "Strg-C": Abbruch des Programms', hellrot);
   zeichneGrafstring(0, ym-5-0*zHoehe, '     sonst: ein Zeitschritt weiter', hellrot);
   Einzelschritt:=true;
   zeichneZeitgleichung:=false;
   zeichneAnalemma:=false;
   zeichneTageslaenge:=true;
   zeichneHimmel:=true;
   zeichnePunkt:=false;
   Verzoegerung:=256;
   nrSp:=0;
   vorigeSonne:=false;
   end;

procedure parEingabe; far;

   begin
   if not Grundfenster.active then Exit;
   if not init then Initialisierung;
   Fenstertitel:='  Eingabe der Parameter';
   loescheBildschirm;
   Information(Infodatei, 'Courier', '25. Februar 2015', schwarz);
   liesChar('Sollen die Parameter der Erdbahn verndert werden (j/n) ?', VeraenderungC);
   Veraenderung:=VeraenderungC in ['j','J'];
   if Veraenderung
      then
         begin
         liesReal('Um welchen Faktor soll die Ekliptikschiefe verndert werden?', SchiefeFaktorStr, SchiefeFaktor);
         Schiefe:=SchiefeFaktor<>0.0;
         liesReal('Um welchen Faktor soll die Exzentrizitt verndert werden?', exzFaktorStr, exzFaktor);
         Exzentrizitaet:=exzFaktor<>0.0;
         liesReal('Verschiebung des Periheldurchgangs in Tagen', deltamStr, deltam);
         deltam:=deltam*ZweiPi/365.25;
         end
      else
         begin
         SchiefeFaktor:=1.0; exzFaktor:=1.0; deltam:=0.0; Schiefe:=true; Exzentrizitaet:=true
         end;
   liesChar('Soll die Innenseite der Himmelskugel dargestellt werden (j/n) ?', RueckseiteC);
   Rueckseite:=RueckseiteC in ['j','J'];
   Vorbereitung;
   started:=true; Abbruch:=false; Pause:=false;
   end;

procedure Ausgabe;

   var zg, zg1, Tageslaenge, Tageslaenge1: real;
       Datum: Zeitpunkt;
       alphaS, alphaSm, temp1, temp2: real;
       s, s1: String;
       xp, yp, Farbe: integer;

   procedure zeichneAnalemmapunkt(delta, zg: real; Farbe: integer);

      var x, y, f: integer;

      begin
      setzeBildschirmausschnitt(0, 200, 200, ym-200);
      setzeTextausrichtung(1, 0);
      waehleFont('Courier', 12, 1);
      if zeichneAnalemma then f:=schwarz else f:=weiss;
      zeichneGrafstring(100, 200, 'Analemma', f);
      zeichneGrafstring(100, 200+zHoehe, 'deltaS(deltat)', f);
      waehleFont('Courier', 12, 0);
      dimensioniereBildschirm(-EklSchiefe/Grad, EklSchiefe/Grad, -30.0, 30.0);
      if zeichneAnalemma then
         begin
         setzeLinienbreite(1);
         waehleFont(Fontname, 8, 0);
         zeichneXAchse(0.0, 0.0, -20.0, 20.0, 5, 2.0, 'deltat', hellgrau, hellgrau);
         zeichneYAchse(0.0, 0.0, -25.0, 25.0, 5, 2.0, 'deltaS', hellgrau, hellgrau);
         end;
      x:=xPlot(zg); y:=yPlot(delta/Grad);
      setzeLinienbreite(2);
      if jd=jd0
         then
            begin
            xAl:=x; yAl:=y
            end
         else if zeichneAnalemma then zeichneLinie(xAl, yAl, x, y, Farbe);
      if zeichnePunkt and zeichneAnalemma then
         begin
         setzeFuelltyp(255, Farbe, Farbe);
         fuelleEllipse(x, y, 3, 3)
         end;
      xAl:=x; yAl:=y
      end;

   begin
   jd:=jd0+jdFaktor*i;
   gregDatum(jd, Datum, Mez);
   setzeBildschirmausschnitt(250, xm-50, 50, ym div 2-50);
   dimensioniereBildschirm(0.0, 366.0, -20.0, 20.0);
   setzeLinienbreite(3);
   if zeichneZeitgleichung then Farbe:=hellrot else Farbe:=weiss;

(******************** exakte Berechnung der Zeitgleichung *********************)

   zg:=Zeitgl(Datum, Mez)/ZweiPi*24.0*60.0;
   if exakt and (i>0) then
      begin
      zeichneLinie(xPlot(jdFaktor*(i-1)), yPlot(zgl), xPlot(jdFaktor*i), yPlot(zg), Farbe);
      if zeichnePunkt and zeichneZeitgleichung then
         begin
         setzeFuelltyp(255, Farbe, Farbe);
         fuelleEllipse(xPlot(jdFaktor*i), yPlot(zg), 3, 3)
         end
      end;
   zgl:=zg;

(****************** Nherungsrechnung fr die Zeitgleichung *******************)

   if vorigeSonne then
      begin
      temp1:=alphal; temp2:=lambdal;
      alphaSv:=alphaSonne(jd-30, exzFaktor*Erdbahn.ex, SchiefeFaktor*EklSchiefe);
      alphal:=temp1; lambdal:=temp2
      end;
   deltaSv:=delta;
   alphaS:=alphaSonne(jd, exzFaktor*Erdbahn.ex, SchiefeFaktor*EklSchiefe);
   alphaSm:=alphaS0+Erdbahn.my*(jd-jd0);
   while alphaSm>ZweiPi do alphaSm:=alphaSm-ZweiPi;
   zg1:=-(alphaS-alphaSm)/Grad*4.0-Summand;
   if zg1>1000.0 then zg1:=zg1-1440;
   if zg1<-1000.0 then zg1:=zg1+1440;
   if zg10=0.0 then zg10:=zg1;
   if not exakt and (i>0) then
      begin
      (*if abs(zg10-zg1)<5 then*) zeichneLinie(xPlot(jdFaktor*(i-1)), yPlot(zg10), xPlot(jdFaktor*i), yPlot(zg1), Farbe);
      if zeichnePunkt and zeichneZeitgleichung then
         begin
         setzeFuelltyp(255, Farbe, Farbe);
         fuelleEllipse(xPlot(jdFaktor*i), yPlot(zg1), 3, 3)
         end
      end;
   setzeLinienbreite(2);
   dimensioniereBildschirm(0.0, 366.0, -30.0, 30.0);

(******************** exakte Berechnung der Tageslnge ************************)

   if i=0 then zg0:=Zeitgl(Datum0, Mez)/ZweiPi*24.0*60.0;
   Tageslaenge:=(zg0-zg)*60/jdFaktor;
   if (Tageslaengel=0.0) or (i=0) then Tageslaengel:=Tageslaenge;
   if zeichneTageslaenge then Farbe:=blau else Farbe:=weiss;
   if exakt and (i>1) then
      begin
      if abs(Tageslaenge-Tageslaengel)<5 then zeichneLinie(xPlot(jdFaktor*(i-1)), yPlot(Tageslaengel), xPlot(jdFaktor*i), yPlot(Tageslaenge), Farbe);
      if zeichnePunkt and zeichneTageslaenge then
         begin
         setzeFuelltyp(255, Farbe, Farbe);
         fuelleEllipse(xPlot(jdFaktor*i), yPlot(Tageslaenge), 2, 2)
         end
      end;
   Tageslaengel:=Tageslaenge;
   zg0:=zg;

(****************** Nherungsrechnung fr die Tageslnge **********************)

   Tageslaenge1:=(zg10-zg1)*60/jdFaktor;
   if Tageslaenge1l=0.0 then Tageslaenge1l:=Tageslaenge1;
   if not exakt and (i*jdFaktor<366) and (i>1) then
      begin
      if abs(Tageslaenge1-Tageslaenge1l)<5 then zeichneLinie(xPlot(jdFaktor*(i-1)), yPlot(Tageslaenge1l), xPlot(jdFaktor*i), yPlot(Tageslaenge1), Farbe);
      if zeichnePunkt and zeichneTageslaenge then
         begin
         setzeFuelltyp(255, Farbe, Farbe);
         fuelleEllipse(xPlot(jdFaktor*i), yPlot(Tageslaenge1), 3, 3)
         end
      end;
   Tageslaenge1l:=Tageslaenge1;
   zg10:=zg1;

   setzeTextausrichtung(0,0);
   xp:=xPlot(0.0)-zBreite; yp:=yPlot(-30.0)+50;
   Str(Datum.Tag:2, s); Str(Datum.Monat:2, s1); zeichneGrafstring(xp, yp, '               Datum = '+s+'.'+s1+'.', schwarz); Inc(yp, 16);
   if SchiefeFaktor<>1.0 then zeichneGrafstring(xp, yp, '     Ekliptik-Faktor = '+SchiefeFaktorStr, schwarz); Inc(yp, 16);
   if exzFaktor<>1.0 then zeichneGrafstring(xp, yp, 'Exzentrizitt-Faktor = '+exzFaktorStr, schwarz); Inc(yp, 16);
   if deltam<>0.0 then zeichneGrafstring(xp, yp, '       delta Perihel = '+deltamStr+' Tage', schwarz); Inc(yp, 16);
   Inc(xp, 12*zBreite); Inc(yp, 16);
   wandleZahlinString(  delta/Grad, 2.1, s); zeichneGrafstring(xp, yp, '   delta = '+s+GradC, schwarz); Inc(yp, 16);
   wandleZahlinString(vlambda, 1.3, s);
   if vlambda<180.0 then zeichneGrafstring(xp, yp, ' vlambda = '+s+GradC+'/d', schwarz); Inc(yp, 16);
   wandleZahlinString( valpha, 1.3, s);
   if valpha<180 then zeichneGrafstring(xp, yp, '  valpha = '+s+GradC+'/d', schwarz); Inc(yp, 16);
   wandleZahlinString(Erdbahn.my/Grad, 1.3, s); zeichneGrafstring(xp, yp, ' valpham = '+s+GradC+'/d', schwarz);
   if zeichneHimmel then zeichnegrHimmelskugel(jd0, jd, alphaS0, alphaS, delta);
   if i*jdFaktor<366 then Inc(i) else i:=0;
   zeichneAnalemmapunkt(delta, zg1, hellrot);      (* mit Nherung berechnet! *)
   waehleFont(Fontname, Fontsize, Fontstyle);
   setzeTextausrichtung(0, 0);
   if Einzelschritt
      then zeichneGrafstring(0, ym-5-2*zHoehe, ' "<-"/"->": langsamer/schneller', weiss)
      else zeichneGrafstring(0, ym-5-2*zHoehe, ' "<-"/"->": langsamer/schneller', hellrot);
   warte(Verzoegerung)
   end;

procedure Pausenanfangprozedur;

   begin
   Info1Str:='Pausenanfang';
   Pause:=true;
   end;

procedure Pausenendeprozedur;

   begin
   Info1Str:=' "p": Pause, "Esc": Abbruch';
   Pause:=false
   end;

procedure Schleife; far;

   begin
   if not started then Start;
   if Abbruch or not started then Exit;
   if TasteGedrueckt then
      if Pause then
         begin
         Pausenendeprozedur; Taste:=Tastencode;
         end;
   if Pause or (Einzelschritt and not TasteGedrueckt) then Exit;
   Taste:=Tastencode;
   case Taste of
      Esc: begin
           Abbruch:=true;
           Info1Str:='Abbruch';
           Start;
           end;
      Ord('p'): Pausenanfangprozedur;
      Ord('d'): zeichnePunkt:=not zeichnePunkt;
      Ord('e'): Einzelschritt:=not Einzelschritt;
      Ord('v'): vorigeSonne:=not vorigeSonne;
      Ord('a'): begin
                zeichneAnalemma:=not zeichneAnalemma;
                if zeichneAnalemma
                   then nrSp:=0
                   else
                      begin
                      setzeFuelltyp(255, weiss, weiss);
                      fuelleRechteck(0, 200, 200, ym-400)
                      end
                end;
      Ord('t'): zeichneTageslaenge:=not zeichneTageslaenge;
      Ord('h'): begin
                zeichneHimmel:=not zeichneHimmel;
                if not zeichneHimmel then
                   begin
                   setzeFuelltyp(255, weiss, weiss);
                   fuelleRechteck(xm-ym-100, ym div 2-50, ym, ym div 2+50);
                   end
                end;
      Ord('z'): zeichneZeitgleichung:=not zeichneZeitgleichung;
      CursorRechts: if Verzoegerung>1 then Verzoegerung:=Verzoegerung div 2;
      CursorLinks: Verzoegerung:=Verzoegerung*2;
      Ord('s'): begin
                Inc(BildNr);
                speichereBMP(Bildname+Chr(48+BildNr div 10)+Chr(48+BildNr mod 10)+'.bmp', 0, 0, xm, ym);
                end;
      end;
   if Taste in [Ord('t'), Ord('z'), Ord('a')] then schreibeTitelzeile;
   Ausgabe;
   end;

begin (* Hauptprogramm *)
init:=false;
Application.CreateForm(TGrundfenster, Grundfenster);
  Application.CreateForm(TEingabeDialog, EingabeDialog);
  initProgram(inBitmap, Infotext, Startbild, Fontname, Fontsize, Fontstyle);

start:=parEingabe;
run:=Schleife;

Application.Run;                                (* Start der Programmschleife *)
end.
